package no.rwr.x;
import gnu.gcj.RawData;


public final class XAnyEvent {

    // FIXME: not good
    public static final int TYPE_EXPOSE = 12;
    public static final int TYPE_UNMAP_NOTIFY = 18;
    public static final int TYPE_CLIENT_MESSAGE = 33;
    public static final int TYPE_BUTTON_PRESS   = 4;
    public static final int TYPE_BUTTON_RELEASE = 5;

    // FIXME: this is not good.
    public final static long MASK_SUBSTRUCTURE_NOTIFY   = 1L<<19;
    public final static long MASK_SUBSTRUCTURE_REDIRECT = 1L<<20;

    XAnyEvent(Display display) {
	this.display = display;
	init();
    }


    private native void init();
    protected native void finalize();

    public native void loadNext();

    public native int getType();
    public native void setType(int type);

    public native Window getWindow();
    public native void setWindow(Window window);

    /** @returns the number of the last request processed by the server */
    public native long getSerial();

    public native void send(Window destination, boolean propagate,
			    long mask);

    RawData structure;
    Display display;

    public String toString() {
	if (structure == null) {
	    return getClass().getName() + "[no-structure]";
	}
	return getClass().getName() +
	    "[type=" + getType() +
	    ",window=" + getWindow() + "]";
    }
}
