#include <X11/Xlib.h>

#include <gcj/cni.h>
#include "no/rwr/x/Display.h"
#include "no/rwr/x/XException.h"

jstring no::rwr::x::XException::toString(Display* display, jint status) {
    ::Display* dpy = (::Display*) (display->display);

    const int ERROR_TEXT_LENGTH = 256;
    char errorText[ERROR_TEXT_LENGTH];

    XGetErrorText(dpy, status, errorText, ERROR_TEXT_LENGTH);
    return JvNewStringLatin1(errorText);
}
